/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2013 Nuvoton Technology Corp. All rights reserved.                                         */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/

//***********************************************************************************************************
//  Nuvoton Technology Corp. 
//  E-Mail: MicroC-8bit@nuvoton.com
//  Date: 20/May/2013
//***********************************************************************************************************

#include <stdio.h>
#include "N78E055A_059A_517A.h"

/*
//-------- <<< Use Configuration Wizard in Context Menu >>> ------------------
//
// <o0> Pre-Scalar Divider
//      <0=> 1/1     
//      <1=> 1/4     
//      <2=> 1/8     
//      <3=> 1/32    
//      <4=> 1/64    
//      <5=> 1/256    
//      <6=> 1/512   
//      <7=> 1/1024   
//
//-------- <<< end of configuration section >>> ------------------------------
*/

#define PRE_SCALAR  0x00

//------------------------------------------------------------------------------
void PDT_ISR(void) interrupt 9
{               
    /* Clear PDT interrupt Flag */
    PDCON &= ~0x20;

    /* Show message */    
    P1 = ~P1;
}
//------------------------------------------------------------------------------
void main(void)
{
    /* Set the time-out periods for the Power-down Timer */
    PDCON |=  PRE_SCALAR;

    /* Reset Power Down timer counter */
    PDCON |= 0x40;
    while ((PDCON & 0x40) != 0);

    /* Enable Power-down Timer interrupt */
    EIE |= 0x02;
    EA = 1;

    /* Enable Power-down Timer */
    PDCON |= 0x80;

    /* Enter Power-down */
    while(1)
        PCON |= 0x02;
}
