/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2013 Nuvoton Technology Corp. All rights reserved.                                         */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/

//***********************************************************************************************************
//  Nuvoton Technology Corp. 
//  E-Mail: MicroC-8bit@nuvoton.com
//  Date: 20/May/2013 
//***********************************************************************************************************

#include "Timer2.h"
#if DEMO == 2

/*===========================================================================================================
 * Before using this demo code, please set DEMO in "TImer2.h" to decide which *.c is used for different 
 * timer modes.
 *
 * This file set up Timer 2 in Clock-Out mode. Clock-out outputs from P1.0. P1.3 toggles each external T2EX
 * interrupt.
 *=========================================================================================================*/

#include "N78E055A_059A_517A.h"

#define RELOAD_VALUE_H  0xff
#define RELOAD_VALUE_L  0x00

/************************************************************************************************************
*    TIMER 2 interrupt subroutine
************************************************************************************************************/
void Timer2_ISR (void) interrupt 5  //interrupt address is 0x002B
{
    EXF2 = 0;
    P13 = ~P13;                     //P1.3 toggle when external EXF2 interrupt
}

/************************************************************************************************************
*    Main function 
************************************************************************************************************/
void main (void)
{
    T2CON |= 0x08;                  //Timer 2 mode configuration by setting T2CON and T2MOD registers
    EXEN2 = 1;                      //enable T2EX pin reload
    T2MOD = 0x02;                   //select Clock-out mode
    
    TH2 = RELOAD_VALUE_H;           //initial counter values 
    TL2 = RELOAD_VALUE_L;    
    RCAP2H = RELOAD_VALUE_H;
    RCAP2L = RELOAD_VALUE_L;    
    
    ET2 = 1;                        //enable Timer2 interrupt
    EA = 1;                         //enable interrupts
    TR2 = 1;                        //Timer2 run

    while(1);
}

#endif